/*
 * SheerCMS version 0.9.0 - January 2008
 *  2006 - 2008 James Hurst, Jim@sheercms.co.uk
 * 
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the Affero General Public License (AGPL) as published by Affero, 
 * Inc. version 1. All files in the SheerCMS distribution are covered by this licence, 
 * except where noted.
 * 
 * IMPORTANT NOTICE: As covered by the AGPL Section 2(d), the "Powered by SheerCMS" 
 * (or similar) link to SheerCMS.co.uk must under no circumstances be removed or 
 * obfuscated in from pages generated by this program. The required link must be 
 * static, visible and readable. This also applies when being used for testing 
 * purposes or on an intranet or internal network.
 * 
 * Please be aware, that the AGPL in Section 2(d) requires, that any modified 
 * version of the program run publicly (ie. on the Internet) must have an additional 
 * download facility for the modified version. This also applies to any modification 
 * of the template.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the AGPL for more details.
 * 
 * A copy of the Affero General Public License is available at SheerCMS.co.uk, 
 * if not, write to Affero, Inc., 510 Third Street, Suite 225, San Francisco, 
 * CA 94107 USA.
 * 
 * This copyright note must under no circumstances be removed from this 
 * file and any distribution of code covered by this licence.
 * 
 * For downloads and information about installation, 
 * please see http://www.sheercms.co.uk/
*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using SheerCMS.Internals;

namespace SheerCMS
{
    public class Global : HttpApplication
    {
        public Global()
        {
            this.BeginRequest += new EventHandler(Global_BeginRequest);
        }

        void Global_BeginRequest(object sender, EventArgs e)
        {
            if (CMSGlobalSettings.FriendlyURL)
            {
                // Rewrites the internal url from the friendly name to the internal url.
                if (string.IsNullOrEmpty(this.Request.QueryString["id"]))
                {
                    string fileName = "/" + this.Request.Url.GetComponents(UriComponents.Path, UriFormat.Unescaped);

                    foreach (PageDefinition pageDef in PageManager.Instance)
                    {
                        if (pageDef.FriendlyFileName.ToUpper() == fileName.ToUpper())
                        {
                            this.Context.RewritePath(CMSGlobalSettings.BaseFolder + pageDef.Template + ".aspx?id=" + pageDef.ID);
                            break;
                        }
                    }
                }
                else
                {
                    // Catches non friendly name requests and redirects them to the friendly named url.
                    int id;

                    if (int.TryParse(this.Request.QueryString["id"], out id))
                        this.Response.Redirect(PageManager.Instance[id].FriendlyFileName);
                }
            }
        }
    }
}
