/*
 * SheerCMS version 0.9.0 - January 2008
 *  2006 - 2008 James Hurst, Jim@sheercms.co.uk
 * 
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the Affero General Public License (AGPL) as published by Affero, 
 * Inc. version 1. All files in the SheerCMS distribution are covered by this licence, 
 * except where noted.
 * 
 * IMPORTANT NOTICE: As covered by the AGPL Section 2(d), the "Powered by SheerCMS" 
 * (or similar) link to SheerCMS.co.uk must under no circumstances be removed or 
 * obfuscated in from pages generated by this program. The required link must be 
 * static, visible and readable. This also applies when being used for testing 
 * purposes or on an intranet or internal network.
 * 
 * Please be aware, that the AGPL in Section 2(d) requires, that any modified 
 * version of the program run publicly (ie. on the Internet) must have an additional 
 * download facility for the modified version. This also applies to any modification 
 * of the template.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the AGPL for more details.
 * 
 * A copy of the Affero General Public License is available at SheerCMS.co.uk, 
 * if not, write to Affero, Inc., 510 Third Street, Suite 225, San Francisco, 
 * CA 94107 USA.
 * 
 * This copyright note must under no circumstances be removed from this 
 * file and any distribution of code covered by this licence.
 * 
 * For downloads and information about installation, 
 * please see http://www.sheercms.co.uk/
*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace SheerCMS.Internals
{
    public class GuestBookEntry 
    {
        private int i_id = 0;
        private DateTime i_date = DateTime.Now;
        private string i_author = string.Empty;
        private string i_email = string.Empty;
        private string i_contents = string.Empty;

        /// <summary>
        /// 
        /// </summary>
        public GuestBookEntry() { }

        internal GuestBookEntry(XmlNode node)
        {
            if (node.Name == "entry")
            {
                if (node.Attributes["id"].InnerText != string.Empty)
                    i_id = int.Parse(node.Attributes["id"].InnerText);

                if (node.Attributes["date"].InnerText != string.Empty)
                    i_date = DateTime.Parse(node.Attributes["date"].InnerText);
                
                i_author = node.Attributes["author"].InnerText;
                i_email = node.Attributes["email"].InnerText;

                XmlNode childNode = node.ChildNodes[0];
                if (childNode is XmlCDataSection)
                    i_contents = childNode.Value;
                else
                    i_contents = node.InnerText;
            }
            else
                throw new Exception();//TODO: Add correct Exception message
        }

        /// <summary>
        /// 
        /// </summary>
        public int ID
        {
            get { return i_id; }
            set { i_id = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public DateTime Date
        {
            get { return i_date; }
            set { i_date = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public string Author
        {
            get { return i_author; }
            set { i_author = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public string Email
        {
            get { return i_email; }
            set { i_email = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        public string Contents
        {
            get { return i_contents; }
            set { i_contents = value; }
        }
    }
}
