/*
 * SheerCMS version 0.9.0 - January 2008
 *  2006 - 2008 James Hurst, Jim@sheercms.co.uk
 * 
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the Affero General Public License (AGPL) as published by Affero, 
 * Inc. version 1. All files in the SheerCMS distribution are covered by this licence, 
 * except where noted.
 * 
 * IMPORTANT NOTICE: As covered by the AGPL Section 2(d), the "Powered by SheerCMS" 
 * (or similar) link to SheerCMS.co.uk must under no circumstances be removed or 
 * obfuscated in from pages generated by this program. The required link must be 
 * static, visible and readable. This also applies when being used for testing 
 * purposes or on an intranet or internal network.
 * 
 * Please be aware, that the AGPL in Section 2(d) requires, that any modified 
 * version of the program run publicly (ie. on the Internet) must have an additional 
 * download facility for the modified version. This also applies to any modification 
 * of the template.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the AGPL for more details.
 * 
 * A copy of the Affero General Public License is available at SheerCMS.co.uk, 
 * if not, write to Affero, Inc., 510 Third Street, Suite 225, San Francisco, 
 * CA 94107 USA.
 * 
 * This copyright note must under no circumstances be removed from this 
 * file and any distribution of code covered by this licence.
 * 
 * For downloads and information about installation, 
 * please see http://www.sheercms.co.uk/
*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using SheerCMS.Internals;
using System.Xml;

namespace SheerCMS
{
    public class RSSOutputControl : WebControl
    {

        protected override void RenderContents(HtmlTextWriter writer)
        {
            string strId = this.Page.Request.QueryString["id"];

            try
            {
                int cnt = this.Page.Request.Url.AbsoluteUri.LastIndexOf("/");
                string baseSiteUrl = this.Page.Request.Url.AbsoluteUri.Substring(0, cnt+1);
                int id = int.Parse(strId);

                ListEntryManager list = ListsManager.Instance[id];

                if (list != null)
                {
                    XmlDocument document = new XmlDocument();

                    XmlNode rssNode = document.CreateElement("rss");
                    document.AppendChild(rssNode);

                    XmlAttribute version = document.CreateAttribute("version");
                    version.InnerText = "2.0";
                    rssNode.Attributes.Append(version);

                    XmlNode channel = document.CreateElement("channel");
                    rssNode.AppendChild(channel);

                    XmlNode node = document.CreateElement("title");
                    node.InnerText = list.Title;
                    channel.AppendChild(node);

                    node = document.CreateElement("link");
                    node.InnerText = baseSiteUrl;
                    channel.AppendChild(node);

                    node = document.CreateElement("description");
                    node.InnerText = list.Description;
                    channel.AppendChild(node);

                    XmlNode item;

                    foreach (ListEntry entry in list)
                    {
                        item = document.CreateElement("item");
                        channel.AppendChild(item);

                        node = document.CreateElement("title");
                        node.InnerText = entry.Title;
                        item.AppendChild(node);

                        node = document.CreateElement("description");
                        node.InnerText = entry.Contents;
                        item.AppendChild(node);

                        node = document.CreateElement("pubDate");
                        node.InnerText = entry.Date.ToString("U");
                        item.AppendChild(node); 
                        
                        node = document.CreateElement("link");
                        node.InnerText = baseSiteUrl+entry.Link;
                        item.AppendChild(node);
                    }

                    writer.WriteLine(document.InnerXml);
                }
            }
            catch { }
        }

        public override void RenderBeginTag(HtmlTextWriter writer) { }

        public override void RenderEndTag(HtmlTextWriter writer) { }

    }
}
