/*
 * SheerCMS version 0.9.0 - January 2008
 *  2006 - 2008 James Hurst, Jim@sheercms.co.uk
 * 
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the Affero General Public License (AGPL) as published by Affero, 
 * Inc. version 1. All files in the SheerCMS distribution are covered by this licence, 
 * except where noted.
 * 
 * IMPORTANT NOTICE: As covered by the AGPL Section 2(d), the "Powered by SheerCMS" 
 * (or similar) link to SheerCMS.co.uk must under no circumstances be removed or 
 * obfuscated in from pages generated by this program. The required link must be 
 * static, visible and readable. This also applies when being used for testing 
 * purposes or on an intranet or internal network.
 * 
 * Please be aware, that the AGPL in Section 2(d) requires, that any modified 
 * version of the program run publicly (ie. on the Internet) must have an additional 
 * download facility for the modified version. This also applies to any modification 
 * of the template.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the AGPL for more details.
 * 
 * A copy of the Affero General Public License is available at SheerCMS.co.uk, 
 * if not, write to Affero, Inc., 510 Third Street, Suite 225, San Francisco, 
 * CA 94107 USA.
 * 
 * This copyright note must under no circumstances be removed from this 
 * file and any distribution of code covered by this licence.
 * 
 * For downloads and information about installation, 
 * please see http://www.sheercms.co.uk/
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using SheerCMS.Internals;

public partial class Administration_GuestbookManager : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            PopulateEntryList();
        }
    }

    protected void btn_save_Click(object sender, EventArgs e)
    {
        lock (GuestBookManager.Instance)
        {
            GuestBookEntry entry = GuestBookManager.Instance[int.Parse(entry_list.SelectedValue)];
            entry.Contents = content_editor.Text;
            GuestBookManager.Instance.UpdateContent();
        }
        PopulateEntryList();
        PopulateEntryDetails();
    }

    protected void btn_delete_Click(object sender, EventArgs e)
    {
        lock (GuestBookManager.Instance)
        {
            GuestBookManager.Instance.Remove(int.Parse(entry_list.SelectedValue));
            GuestBookManager.Instance.UpdateContent();
        }
        PopulateEntryList();
        PopulateEntryDetails();
    }

    protected void entry_list_SelectedIndexChanged(object sender, EventArgs e)
    {
        PopulateEntryDetails();
    }

    private void PopulateEntryDetails()
    {
        if (entry_list.SelectedIndex == -1)
        {
            author_textbox.Text = string.Empty;
            email_textbox.Text = string.Empty;
            date_textbox.Text = string.Empty;
            content_editor.Text = string.Empty;
            btn_upper_save.Enabled = false;
            btn_upper_delete.Enabled = false;
            btn_lower_save.Enabled = false;
            btn_lower_delete.Enabled = false;
        }
        else
        {
            GuestBookEntry entry = GuestBookManager.Instance[int.Parse(entry_list.SelectedValue)];
            author_textbox.Text = entry.Author;
            email_textbox.Text = entry.Email;
            date_textbox.Text = entry.Date.ToShortDateString();
            content_editor.Text = entry.Contents;
            btn_upper_save.Enabled = true;
            btn_upper_delete.Enabled = true;
            btn_lower_save.Enabled = true;
            btn_lower_delete.Enabled = true;
        }
    }

    private void PopulateEntryList()
    {
        entry_list.Items.Clear();
        foreach (GuestBookEntry entry in GuestBookManager.Instance)
        {
            entry_list.Items.Add(new ListItem(entry.Author + " - " + entry.Date.ToShortDateString(), entry.ID.ToString()));
        }
    }
}
