<%@ Page Language="C#" AutoEventWireup="true" CodeFile="PageEditor.aspx.cs" Inherits="Administration_PageEditor" ValidateRequest="false" %>
<%@ Register TagPrefix="FCKeditorV2" Namespace="FredCK.FCKeditorV2" Assembly="FredCK.FCKeditorV2" %>
<%@ Register Src="PageMenu.ascx" TagName="pagemenu" TagPrefix="Admin" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head runat="server">
    <title>Pages Editor</title>
    <link rel="Stylesheet" type="text/css" media="Screen" href='administration.css' charset="iso-8859-1" />
</head>
<body>
    <form id="form1" runat="server">
    <div id="page-content">
        <Admin:pagemenu ID="menu" SelectMenuOption="menu_pages" runat="server" />
        <div id="selection_panel" class="layout-panel" runat="server">

            <h1>Select page to edit:</h1>
            
            <div class="editor-element">
                <asp:Button ID="btn_upper_add" CssClass="button button-margin" runat="server" Text="Add" OnClick="btn_add_Click" />
                <asp:Button ID="btn_upper_edit" CssClass="button button-margin" runat="server" Text="Edit" OnClick="btn_edit_Click"/>
                <asp:Button ID="btn_upper_remove" CssClass="button" runat="server" Text="Remove" OnClientClick="return confirm('Pages that are deleted cannot be recovered, continue deleting selected page?');" OnClick="btn_remove_Click" />
            </div>
            
            <div class="editor-element">
                <asp:ListBox ID="page_list" CssClass="item_list" runat="server"></asp:ListBox>
            </div>
            
            <div class="editor-element">
                <asp:Button ID="btn_lower_add" CssClass="button button-margin" runat="server" Text="Add" OnClick="btn_add_Click" />
                <asp:Button ID="btn_lower_edit" CssClass="button button-margin" runat="server" Text="Edit" OnClick="btn_edit_Click"/>
                <asp:Button ID="btn_lower_remove" CssClass="button" runat="server" Text="Remove" OnClientClick="return confirm('Pages that are deleted cannot be recovered, continue deleting selected page?');" OnClick="btn_remove_Click" />
            </div>
        </div>
        
        <div id="editor_form" class="layout-panel" runat="server" visible="false">
            <h1>Edit page:</h1>
            
            <asp:ValidationSummary ID="ValSummary" runat="server" CssClass="validation-summary" DisplayMode="List" ShowSummary="true" />
            
            <div class="editor-element">
                <asp:Label ID="id_label" runat="server" CssClass="label" AssociatedControlID="id_textbox">Page Id: </asp:Label> 
                <asp:TextBox ID="id_textbox" runat="server" CssClass="edit-textbox" Enabled="False" ></asp:TextBox>
            </div>
            
            
            <div class="editor-element">
                <asp:Label ID="url_label" runat="server" CssClass="label" AssociatedControlID="url_textbox">Page URL: </asp:Label> 
                <asp:TextBox ID="url_textbox" runat="server" CssClass="edit-textbox" Enabled="False" ></asp:TextBox>
            </div>
            
            <div class="editor-element">
                <asp:Label ID="pagetitle_label" runat="server" CssClass="label" ToolTip="This is used as the page title." AssociatedControlID="pagetitle_textbox">Page Title: *</asp:Label> 
                <asp:TextBox ID="pagetitle_textbox" runat="server" CssClass="edit-textbox" ></asp:TextBox><br />
                <asp:RequiredFieldValidator ID="pagetitle_reqField" runat="server" EnableClientScript="true" Display="None" ControlToValidate="pagetitle_textbox" ErrorMessage="Please enter a Page Title."></asp:RequiredFieldValidator>
            </div>
            
            <div class="editor-element">
                <asp:Label ID="title_label" runat="server" CssClass="label" ToolTip="This is used as the link text in menu and automatically created controls." AssociatedControlID="title_textbox">Short Title: *</asp:Label> 
                <asp:TextBox ID="title_textbox" runat="server" CssClass="edit-textbox" ></asp:TextBox><br />
                <asp:RequiredFieldValidator ID="title_reqField" runat="server" EnableClientScript="true" Display="None" ControlToValidate="title_textbox" ErrorMessage="Please enter a Short Title."></asp:RequiredFieldValidator>
                <asp:CustomValidator ID="title_custVal" runat="server" EnableClientScript="false" ControlToValidate="title_textbox" Display="None" ErrorMessage="This title is already assigned to another page, please enter another title." OnServerValidate="title_custVal_ServerValidate" />
                <asp:RegularExpressionValidator ID="title_regExp" runat="server" EnableClientScript="true" ControlToValidate="title_textbox" Display="None" ErrorMessage="This title uses invalid characters, please only use letters, numbers and a space." ValidationExpression="^[a-zA-Z0-9\s]{1,40}$" />
            </div>
            
            <div class="editor-element">
                <asp:Label ID="summary_label" runat="server" CssClass="label" ToolTip="This is used as the title attribute in menu and automatically created controls. Also used as the metadata description for the page." AssociatedControlID="summary_textbox">Page Summary: </asp:Label> 
                <asp:TextBox ID="summary_textbox" runat="server" CssClass="edit-textbox" ></asp:TextBox><br />
            </div>
                       
            <div class="editor-element">
                <asp:Label ID="menuList_label" runat="server" CssClass="label" AssociatedControlID="menuList_checkbox">List in menu: </asp:Label>
                <asp:CheckBox ID="menuList_checkbox" runat="server" />
            </div>
            
            <div class="editor-element">
                <asp:Label ID="template_label" runat="server" CssClass="label" AssociatedControlID="template_dropdown">Template Name: </asp:Label> 
                <asp:DropDownList ID="template_dropdown" CssClass="edit-textbox" runat="server"></asp:DropDownList><br />
            </div>
            
            <div class="editor-element">
                <asp:Label ID="content_label" runat="server" CssClass="label" AssociatedControlID="content_editor">Page Content:</asp:Label><br />
                <FCKeditorV2:FCKeditor id="content_editor" HtmlEncodeOutput="false" Width="800" Height="500" ToolbarSet="CMS" BasePath="~/fckeditor/" runat="server" />
            </div>
            
            <div class="editor-element">
                <p><small>* Mandatory fields.</small></p>
            </div>
            
            <div class="editor-element">
                <asp:Button ID="btn_save" CssClass="button button-margin" runat="server" Text="Save" OnClick="btn_save_Click" />
                <asp:Button ID="btn_save_close" CssClass="button-long button-margin"  runat="server"  Text="Save and Close" OnClick="btn_save_close_Click" />
                <asp:Button ID="btn_preview" CssClass="button button-margin" runat="server" Text="Preview" OnClick="btn_preview_Click"/>
                <asp:Button ID="btn_cancel" CssClass="button " runat="server" Text="Cancel" OnClientClick="return confirm('Closing the page editor without saving will lose any unsaved changes, continue?');" OnClick="btn_cancel_Click" />
            </div>
        </div>
        
        <div id="preview_form" class="layout-panel" runat="server" visible="false">
            <iframe id="preview_frame" class="preview" runat="server" />
            <asp:Button ID="btn_preview_cancel" CssClass="button " runat="server" Text="Cancel" OnClick="btn_preview_cancel_Click" />
        </div>
        
    </div>
    </form>
    
</body>
</html>
