/*
 * SheerCMS version 0.9.0 - January 2008
 *  2006 - 2008 James Hurst, Jim@sheercms.co.uk
 * 
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the Affero General Public License (AGPL) as published by Affero, 
 * Inc. version 1. All files in the SheerCMS distribution are covered by this licence, 
 * except where noted.
 * 
 * IMPORTANT NOTICE: As covered by the AGPL Section 2(d), the "Powered by SheerCMS" 
 * (or similar) link to SheerCMS.co.uk must under no circumstances be removed or 
 * obfuscated in from pages generated by this program. The required link must be 
 * static, visible and readable. This also applies when being used for testing 
 * purposes or on an intranet or internal network.
 * 
 * Please be aware, that the AGPL in Section 2(d) requires, that any modified 
 * version of the program run publicly (ie. on the Internet) must have an additional 
 * download facility for the modified version. This also applies to any modification 
 * of the template.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the AGPL for more details.
 * 
 * A copy of the Affero General Public License is available at SheerCMS.co.uk, 
 * if not, write to Affero, Inc., 510 Third Street, Suite 225, San Francisco, 
 * CA 94107 USA.
 * 
 * This copyright note must under no circumstances be removed from this 
 * file and any distribution of code covered by this licence.
 * 
 * For downloads and information about installation, 
 * please see http://www.sheercms.co.uk/
*/
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml.XPath;
using System.Text;
using SheerCMS;
using SheerCMS.Internals;

public partial class CMS_SearchResults : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        DoSearch(Session["SearchString"].ToString());
        Session["SearchString"] = string.Empty;
    }

    private void DoSearch(string searchText)
    {
        StringBuilder builder = new StringBuilder();

        
        XPathDocument doc = new XPathDocument(this.Page.Request.PhysicalApplicationPath + "Content\\content.xml");
        XPathNavigator navigator = doc.CreateNavigator();

        XPathNodeIterator nodes = navigator.Select(
            "//content/pages/page[contains(translate(.,'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')," +
            " translate('" + searchText + "','ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz'))]");


        foreach (XPathNavigator node in nodes)
        {
            builder.Append("<a href=\"");

            if (CMSGlobalSettings.FriendlyURL)
            {
                int id = int.Parse(node.SelectSingleNode("@id").Value);
                builder.Append(PageManager.Instance[id].FriendlyFileName);
            }
            else
                builder.Append(this.Page.ResolveUrl("~/" + node.SelectSingleNode("@template").Value + ".aspx?id=" + node.SelectSingleNode("@id").Value));
            
            builder.Append("\" title=\"");
            builder.Append(node.SelectSingleNode("@title").Value);
            builder.Append("\" >");
            builder.Append(node.SelectSingleNode("@title").Value);
            builder.Append("</a>");
        }

        if (builder.ToString() == string.Empty)
            search_content.Text = "Sorry, We could not find any results containing "+searchText;
        else
            search_content.Text = builder.ToString();
        
    }
}
